-- BITMAP GENERATOR --
-- Source bitmap: smile_lol_2.bmp


library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package smile_lol_2 is
	--- bitmap pixels ---
	function pix_r(col: std_logic_vector; row: std_logic_vector) return std_logic_vector;
	function pix_g(col: std_logic_vector; row: std_logic_vector) return std_logic_vector;
	function pix_b(col: std_logic_vector; row: std_logic_vector) return std_logic_vector;

	--- bitmap size ---
	constant bmpx: integer := 15;
	constant bmpy: integer := 15;
	constant bitx: integer := 4;
	constant bity: integer := 4;
end smile_lol_2;

package body smile_lol_2 is
	--- bitmap red pixels ---
	function pix_r(col: std_logic_vector; row: std_logic_vector) return std_logic_vector is
		variable pix: integer range 0 to 2**5-1;
	begin
		   if (col=0   and row=0  ) then pix := 0;
		elsif (col=1   and row=0  ) then pix := 0;
		elsif (col=2   and row=0  ) then pix := 0;
		elsif (col=3   and row=0  ) then pix := 0;
		elsif (col=4   and row=0  ) then pix := 0;
		elsif (col=5   and row=0  ) then pix := 12;
		elsif (col=6   and row=0  ) then pix := 8;
		elsif (col=7   and row=0  ) then pix := 6;
		elsif (col=8   and row=0  ) then pix := 8;
		elsif (col=9   and row=0  ) then pix := 12;
		elsif (col=10  and row=0  ) then pix := 0;
		elsif (col=11  and row=0  ) then pix := 0;
		elsif (col=12  and row=0  ) then pix := 0;
		elsif (col=13  and row=0  ) then pix := 0;
		elsif (col=14  and row=0  ) then pix := 0;
		elsif (col=0   and row=1  ) then pix := 0;
		elsif (col=1   and row=1  ) then pix := 0;
		elsif (col=2   and row=1  ) then pix := 0;
		elsif (col=3   and row=1  ) then pix := 10;
		elsif (col=4   and row=1  ) then pix := 10;
		elsif (col=5   and row=1  ) then pix := 17;
		elsif (col=6   and row=1  ) then pix := 20;
		elsif (col=7   and row=1  ) then pix := 21;
		elsif (col=8   and row=1  ) then pix := 20;
		elsif (col=9   and row=1  ) then pix := 17;
		elsif (col=10  and row=1  ) then pix := 10;
		elsif (col=11  and row=1  ) then pix := 10;
		elsif (col=12  and row=1  ) then pix := 0;
		elsif (col=13  and row=1  ) then pix := 0;
		elsif (col=14  and row=1  ) then pix := 0;
		elsif (col=0   and row=2  ) then pix := 0;
		elsif (col=1   and row=2  ) then pix := 0;
		elsif (col=2   and row=2  ) then pix := 9;
		elsif (col=3   and row=2  ) then pix := 14;
		elsif (col=4   and row=2  ) then pix := 19;
		elsif (col=5   and row=2  ) then pix := 19;
		elsif (col=6   and row=2  ) then pix := 20;
		elsif (col=7   and row=2  ) then pix := 20;
		elsif (col=8   and row=2  ) then pix := 20;
		elsif (col=9   and row=2  ) then pix := 19;
		elsif (col=10  and row=2  ) then pix := 19;
		elsif (col=11  and row=2  ) then pix := 14;
		elsif (col=12  and row=2  ) then pix := 9;
		elsif (col=13  and row=2  ) then pix := 0;
		elsif (col=14  and row=2  ) then pix := 0;
		elsif (col=0   and row=3  ) then pix := 0;
		elsif (col=1   and row=3  ) then pix := 10;
		elsif (col=2   and row=3  ) then pix := 12;
		elsif (col=3   and row=3  ) then pix := 15;
		elsif (col=4   and row=3  ) then pix := 11;
		elsif (col=5   and row=3  ) then pix := 3;
		elsif (col=6   and row=3  ) then pix := 4;
		elsif (col=7   and row=3  ) then pix := 12;
		elsif (col=8   and row=3  ) then pix := 4;
		elsif (col=9   and row=3  ) then pix := 3;
		elsif (col=10  and row=3  ) then pix := 11;
		elsif (col=11  and row=3  ) then pix := 15;
		elsif (col=12  and row=3  ) then pix := 12;
		elsif (col=13  and row=3  ) then pix := 10;
		elsif (col=14  and row=3  ) then pix := 0;
		elsif (col=0   and row=4  ) then pix := 0;
		elsif (col=1   and row=4  ) then pix := 8;
		elsif (col=2   and row=4  ) then pix := 13;
		elsif (col=3   and row=4  ) then pix := 12;
		elsif (col=4   and row=4  ) then pix := 4;
		elsif (col=5   and row=4  ) then pix := 11;
		elsif (col=6   and row=4  ) then pix := 11;
		elsif (col=7   and row=4  ) then pix := 3;
		elsif (col=8   and row=4  ) then pix := 11;
		elsif (col=9   and row=4  ) then pix := 11;
		elsif (col=10  and row=4  ) then pix := 4;
		elsif (col=11  and row=4  ) then pix := 12;
		elsif (col=12  and row=4  ) then pix := 13;
		elsif (col=13  and row=4  ) then pix := 8;
		elsif (col=14  and row=4  ) then pix := 0;
		elsif (col=0   and row=5  ) then pix := 12;
		elsif (col=1   and row=5  ) then pix := 11;
		elsif (col=2   and row=5  ) then pix := 9;
		elsif (col=3   and row=5  ) then pix := 10;
		elsif (col=4   and row=5  ) then pix := 7;
		elsif (col=5   and row=5  ) then pix := 11;
		elsif (col=6   and row=5  ) then pix := 11;
		elsif (col=7   and row=5  ) then pix := 7;
		elsif (col=8   and row=5  ) then pix := 11;
		elsif (col=9   and row=5  ) then pix := 11;
		elsif (col=10  and row=5  ) then pix := 7;
		elsif (col=11  and row=5  ) then pix := 10;
		elsif (col=12  and row=5  ) then pix := 9;
		elsif (col=13  and row=5  ) then pix := 11;
		elsif (col=14  and row=5  ) then pix := 12;
		elsif (col=0   and row=6  ) then pix := 8;
		elsif (col=1   and row=6  ) then pix := 11;
		elsif (col=2   and row=6  ) then pix := 5;
		elsif (col=3   and row=6  ) then pix := 8;
		elsif (col=4   and row=6  ) then pix := 8;
		elsif (col=5   and row=6  ) then pix := 9;
		elsif (col=6   and row=6  ) then pix := 9;
		elsif (col=7   and row=6  ) then pix := 9;
		elsif (col=8   and row=6  ) then pix := 9;
		elsif (col=9   and row=6  ) then pix := 9;
		elsif (col=10  and row=6  ) then pix := 8;
		elsif (col=11  and row=6  ) then pix := 8;
		elsif (col=12  and row=6  ) then pix := 5;
		elsif (col=13  and row=6  ) then pix := 11;
		elsif (col=14  and row=6  ) then pix := 8;
		elsif (col=0   and row=7  ) then pix := 6;
		elsif (col=1   and row=7  ) then pix := 10;
		elsif (col=2   and row=7  ) then pix := 0;
		elsif (col=3   and row=7  ) then pix := 1;
		elsif (col=4   and row=7  ) then pix := 3;
		elsif (col=5   and row=7  ) then pix := 4;
		elsif (col=6   and row=7  ) then pix := 4;
		elsif (col=7   and row=7  ) then pix := 4;
		elsif (col=8   and row=7  ) then pix := 4;
		elsif (col=9   and row=7  ) then pix := 4;
		elsif (col=10  and row=7  ) then pix := 3;
		elsif (col=11  and row=7  ) then pix := 1;
		elsif (col=12  and row=7  ) then pix := 0;
		elsif (col=13  and row=7  ) then pix := 10;
		elsif (col=14  and row=7  ) then pix := 6;
		elsif (col=0   and row=8  ) then pix := 8;
		elsif (col=1   and row=8  ) then pix := 9;
		elsif (col=2   and row=8  ) then pix := 1;
		elsif (col=3   and row=8  ) then pix := 23;
		elsif (col=4   and row=8  ) then pix := 27;
		elsif (col=5   and row=8  ) then pix := 23;
		elsif (col=6   and row=8  ) then pix := 27;
		elsif (col=7   and row=8  ) then pix := 23;
		elsif (col=8   and row=8  ) then pix := 27;
		elsif (col=9   and row=8  ) then pix := 23;
		elsif (col=10  and row=8  ) then pix := 27;
		elsif (col=11  and row=8  ) then pix := 23;
		elsif (col=12  and row=8  ) then pix := 1;
		elsif (col=13  and row=8  ) then pix := 9;
		elsif (col=14  and row=8  ) then pix := 8;
		elsif (col=0   and row=9  ) then pix := 12;
		elsif (col=1   and row=9  ) then pix := 8;
		elsif (col=2   and row=9  ) then pix := 3;
		elsif (col=3   and row=9  ) then pix := 16;
		elsif (col=4   and row=9  ) then pix := 31;
		elsif (col=5   and row=9  ) then pix := 27;
		elsif (col=6   and row=9  ) then pix := 31;
		elsif (col=7   and row=9  ) then pix := 27;
		elsif (col=8   and row=9  ) then pix := 31;
		elsif (col=9   and row=9  ) then pix := 27;
		elsif (col=10  and row=9  ) then pix := 31;
		elsif (col=11  and row=9  ) then pix := 16;
		elsif (col=12  and row=9  ) then pix := 3;
		elsif (col=13  and row=9  ) then pix := 8;
		elsif (col=14  and row=9  ) then pix := 12;
		elsif (col=0   and row=10 ) then pix := 0;
		elsif (col=1   and row=10 ) then pix := 6;
		elsif (col=2   and row=10 ) then pix := 6;
		elsif (col=3   and row=10 ) then pix := 4;
		elsif (col=4   and row=10 ) then pix := 23;
		elsif (col=5   and row=10 ) then pix := 26;
		elsif (col=6   and row=10 ) then pix := 30;
		elsif (col=7   and row=10 ) then pix := 26;
		elsif (col=8   and row=10 ) then pix := 30;
		elsif (col=9   and row=10 ) then pix := 26;
		elsif (col=10  and row=10 ) then pix := 23;
		elsif (col=11  and row=10 ) then pix := 4;
		elsif (col=12  and row=10 ) then pix := 6;
		elsif (col=13  and row=10 ) then pix := 6;
		elsif (col=14  and row=10 ) then pix := 0;
		elsif (col=0   and row=11 ) then pix := 0;
		elsif (col=1   and row=11 ) then pix := 10;
		elsif (col=2   and row=11 ) then pix := 7;
		elsif (col=3   and row=11 ) then pix := 6;
		elsif (col=4   and row=11 ) then pix := 5;
		elsif (col=5   and row=11 ) then pix := 14;
		elsif (col=6   and row=11 ) then pix := 25;
		elsif (col=7   and row=11 ) then pix := 23;
		elsif (col=8   and row=11 ) then pix := 25;
		elsif (col=9   and row=11 ) then pix := 14;
		elsif (col=10  and row=11 ) then pix := 5;
		elsif (col=11  and row=11 ) then pix := 6;
		elsif (col=12  and row=11 ) then pix := 7;
		elsif (col=13  and row=11 ) then pix := 10;
		elsif (col=14  and row=11 ) then pix := 0;
		elsif (col=0   and row=12 ) then pix := 0;
		elsif (col=1   and row=12 ) then pix := 0;
		elsif (col=2   and row=12 ) then pix := 8;
		elsif (col=3   and row=12 ) then pix := 8;
		elsif (col=4   and row=12 ) then pix := 10;
		elsif (col=5   and row=12 ) then pix := 7;
		elsif (col=6   and row=12 ) then pix := 5;
		elsif (col=7   and row=12 ) then pix := 4;
		elsif (col=8   and row=12 ) then pix := 5;
		elsif (col=9   and row=12 ) then pix := 7;
		elsif (col=10  and row=12 ) then pix := 10;
		elsif (col=11  and row=12 ) then pix := 8;
		elsif (col=12  and row=12 ) then pix := 8;
		elsif (col=13  and row=12 ) then pix := 0;
		elsif (col=14  and row=12 ) then pix := 0;
		elsif (col=0   and row=13 ) then pix := 0;
		elsif (col=1   and row=13 ) then pix := 0;
		elsif (col=2   and row=13 ) then pix := 0;
		elsif (col=3   and row=13 ) then pix := 10;
		elsif (col=4   and row=13 ) then pix := 7;
		elsif (col=5   and row=13 ) then pix := 9;
		elsif (col=6   and row=13 ) then pix := 11;
		elsif (col=7   and row=13 ) then pix := 12;
		elsif (col=8   and row=13 ) then pix := 11;
		elsif (col=9   and row=13 ) then pix := 9;
		elsif (col=10  and row=13 ) then pix := 7;
		elsif (col=11  and row=13 ) then pix := 10;
		elsif (col=12  and row=13 ) then pix := 0;
		elsif (col=13  and row=13 ) then pix := 0;
		elsif (col=14  and row=13 ) then pix := 0;
		elsif (col=0   and row=14 ) then pix := 0;
		elsif (col=1   and row=14 ) then pix := 0;
		elsif (col=2   and row=14 ) then pix := 0;
		elsif (col=3   and row=14 ) then pix := 0;
		elsif (col=4   and row=14 ) then pix := 0;
		elsif (col=5   and row=14 ) then pix := 11;
		elsif (col=6   and row=14 ) then pix := 8;
		elsif (col=7   and row=14 ) then pix := 6;
		elsif (col=8   and row=14 ) then pix := 8;
		elsif (col=9   and row=14 ) then pix := 11;
		elsif (col=10  and row=14 ) then pix := 0;
		elsif (col=11  and row=14 ) then pix := 0;
		elsif (col=12  and row=14 ) then pix := 0;
		elsif (col=13  and row=14 ) then pix := 0;
		elsif (col=14  and row=14 ) then pix := 0;
		else pix := 0; end if;

		return conv_std_logic_vector(pix,5);
	end pix_r;

	--- bitmap green pixels ---
	function pix_g(col: std_logic_vector; row: std_logic_vector) return std_logic_vector is
		variable pix: integer range 0 to 2**6-1;
	begin
		   if (col=0   and row=0  ) then pix := 0;
		elsif (col=1   and row=0  ) then pix := 0;
		elsif (col=2   and row=0  ) then pix := 0;
		elsif (col=3   and row=0  ) then pix := 0;
		elsif (col=4   and row=0  ) then pix := 0;
		elsif (col=5   and row=0  ) then pix := 51;
		elsif (col=6   and row=0  ) then pix := 48;
		elsif (col=7   and row=0  ) then pix := 46;
		elsif (col=8   and row=0  ) then pix := 48;
		elsif (col=9   and row=0  ) then pix := 51;
		elsif (col=10  and row=0  ) then pix := 0;
		elsif (col=11  and row=0  ) then pix := 0;
		elsif (col=12  and row=0  ) then pix := 0;
		elsif (col=13  and row=0  ) then pix := 0;
		elsif (col=14  and row=0  ) then pix := 0;
		elsif (col=0   and row=1  ) then pix := 0;
		elsif (col=1   and row=1  ) then pix := 0;
		elsif (col=2   and row=1  ) then pix := 0;
		elsif (col=3   and row=1  ) then pix := 49;
		elsif (col=4   and row=1  ) then pix := 49;
		elsif (col=5   and row=1  ) then pix := 56;
		elsif (col=6   and row=1  ) then pix := 59;
		elsif (col=7   and row=1  ) then pix := 60;
		elsif (col=8   and row=1  ) then pix := 59;
		elsif (col=9   and row=1  ) then pix := 56;
		elsif (col=10  and row=1  ) then pix := 49;
		elsif (col=11  and row=1  ) then pix := 49;
		elsif (col=12  and row=1  ) then pix := 0;
		elsif (col=13  and row=1  ) then pix := 0;
		elsif (col=14  and row=1  ) then pix := 0;
		elsif (col=0   and row=2  ) then pix := 0;
		elsif (col=1   and row=2  ) then pix := 0;
		elsif (col=2   and row=2  ) then pix := 47;
		elsif (col=3   and row=2  ) then pix := 54;
		elsif (col=4   and row=2  ) then pix := 59;
		elsif (col=5   and row=2  ) then pix := 58;
		elsif (col=6   and row=2  ) then pix := 58;
		elsif (col=7   and row=2  ) then pix := 59;
		elsif (col=8   and row=2  ) then pix := 58;
		elsif (col=9   and row=2  ) then pix := 58;
		elsif (col=10  and row=2  ) then pix := 59;
		elsif (col=11  and row=2  ) then pix := 54;
		elsif (col=12  and row=2  ) then pix := 47;
		elsif (col=13  and row=2  ) then pix := 0;
		elsif (col=14  and row=2  ) then pix := 0;
		elsif (col=0   and row=3  ) then pix := 0;
		elsif (col=1   and row=3  ) then pix := 47;
		elsif (col=2   and row=3  ) then pix := 53;
		elsif (col=3   and row=3  ) then pix := 56;
		elsif (col=4   and row=3  ) then pix := 48;
		elsif (col=5   and row=3  ) then pix := 33;
		elsif (col=6   and row=3  ) then pix := 33;
		elsif (col=7   and row=3  ) then pix := 47;
		elsif (col=8   and row=3  ) then pix := 33;
		elsif (col=9   and row=3  ) then pix := 33;
		elsif (col=10  and row=3  ) then pix := 48;
		elsif (col=11  and row=3  ) then pix := 56;
		elsif (col=12  and row=3  ) then pix := 53;
		elsif (col=13  and row=3  ) then pix := 47;
		elsif (col=14  and row=3  ) then pix := 0;
		elsif (col=0   and row=4  ) then pix := 0;
		elsif (col=1   and row=4  ) then pix := 47;
		elsif (col=2   and row=4  ) then pix := 55;
		elsif (col=3   and row=4  ) then pix := 54;
		elsif (col=4   and row=4  ) then pix := 35;
		elsif (col=5   and row=4  ) then pix := 48;
		elsif (col=6   and row=4  ) then pix := 48;
		elsif (col=7   and row=4  ) then pix := 32;
		elsif (col=8   and row=4  ) then pix := 48;
		elsif (col=9   and row=4  ) then pix := 48;
		elsif (col=10  and row=4  ) then pix := 35;
		elsif (col=11  and row=4  ) then pix := 54;
		elsif (col=12  and row=4  ) then pix := 55;
		elsif (col=13  and row=4  ) then pix := 47;
		elsif (col=14  and row=4  ) then pix := 0;
		elsif (col=0   and row=5  ) then pix := 47;
		elsif (col=1   and row=5  ) then pix := 52;
		elsif (col=2   and row=5  ) then pix := 52;
		elsif (col=3   and row=5  ) then pix := 52;
		elsif (col=4   and row=5  ) then pix := 42;
		elsif (col=5   and row=5  ) then pix := 53;
		elsif (col=6   and row=5  ) then pix := 53;
		elsif (col=7   and row=5  ) then pix := 43;
		elsif (col=8   and row=5  ) then pix := 53;
		elsif (col=9   and row=5  ) then pix := 53;
		elsif (col=10  and row=5  ) then pix := 42;
		elsif (col=11  and row=5  ) then pix := 52;
		elsif (col=12  and row=5  ) then pix := 52;
		elsif (col=13  and row=5  ) then pix := 52;
		elsif (col=14  and row=5  ) then pix := 47;
		elsif (col=0   and row=6  ) then pix := 43;
		elsif (col=1   and row=6  ) then pix := 52;
		elsif (col=2   and row=6  ) then pix := 41;
		elsif (col=3   and row=6  ) then pix := 50;
		elsif (col=4   and row=6  ) then pix := 50;
		elsif (col=5   and row=6  ) then pix := 51;
		elsif (col=6   and row=6  ) then pix := 51;
		elsif (col=7   and row=6  ) then pix := 51;
		elsif (col=8   and row=6  ) then pix := 51;
		elsif (col=9   and row=6  ) then pix := 51;
		elsif (col=10  and row=6  ) then pix := 50;
		elsif (col=11  and row=6  ) then pix := 50;
		elsif (col=12  and row=6  ) then pix := 41;
		elsif (col=13  and row=6  ) then pix := 52;
		elsif (col=14  and row=6  ) then pix := 43;
		elsif (col=0   and row=7  ) then pix := 40;
		elsif (col=1   and row=7  ) then pix := 52;
		elsif (col=2   and row=7  ) then pix := 26;
		elsif (col=3   and row=7  ) then pix := 28;
		elsif (col=4   and row=7  ) then pix := 31;
		elsif (col=5   and row=7  ) then pix := 33;
		elsif (col=6   and row=7  ) then pix := 34;
		elsif (col=7   and row=7  ) then pix := 34;
		elsif (col=8   and row=7  ) then pix := 34;
		elsif (col=9   and row=7  ) then pix := 33;
		elsif (col=10  and row=7  ) then pix := 31;
		elsif (col=11  and row=7  ) then pix := 28;
		elsif (col=12  and row=7  ) then pix := 26;
		elsif (col=13  and row=7  ) then pix := 52;
		elsif (col=14  and row=7  ) then pix := 40;
		elsif (col=0   and row=8  ) then pix := 41;
		elsif (col=1   and row=8  ) then pix := 50;
		elsif (col=2   and row=8  ) then pix := 29;
		elsif (col=3   and row=8  ) then pix := 51;
		elsif (col=4   and row=8  ) then pix := 55;
		elsif (col=5   and row=8  ) then pix := 46;
		elsif (col=6   and row=8  ) then pix := 55;
		elsif (col=7   and row=8  ) then pix := 46;
		elsif (col=8   and row=8  ) then pix := 55;
		elsif (col=9   and row=8  ) then pix := 46;
		elsif (col=10  and row=8  ) then pix := 55;
		elsif (col=11  and row=8  ) then pix := 51;
		elsif (col=12  and row=8  ) then pix := 29;
		elsif (col=13  and row=8  ) then pix := 50;
		elsif (col=14  and row=8  ) then pix := 41;
		elsif (col=0   and row=9  ) then pix := 44;
		elsif (col=1   and row=9  ) then pix := 46;
		elsif (col=2   and row=9  ) then pix := 34;
		elsif (col=3   and row=9  ) then pix := 46;
		elsif (col=4   and row=9  ) then pix := 63;
		elsif (col=5   and row=9  ) then pix := 54;
		elsif (col=6   and row=9  ) then pix := 63;
		elsif (col=7   and row=9  ) then pix := 54;
		elsif (col=8   and row=9  ) then pix := 63;
		elsif (col=9   and row=9  ) then pix := 54;
		elsif (col=10  and row=9  ) then pix := 63;
		elsif (col=11  and row=9  ) then pix := 46;
		elsif (col=12  and row=9  ) then pix := 34;
		elsif (col=13  and row=9  ) then pix := 46;
		elsif (col=14  and row=9  ) then pix := 44;
		elsif (col=0   and row=10 ) then pix := 0;
		elsif (col=1   and row=10 ) then pix := 38;
		elsif (col=2   and row=10 ) then pix := 44;
		elsif (col=3   and row=10 ) then pix := 32;
		elsif (col=4   and row=10 ) then pix := 53;
		elsif (col=5   and row=10 ) then pix := 52;
		elsif (col=6   and row=10 ) then pix := 60;
		elsif (col=7   and row=10 ) then pix := 52;
		elsif (col=8   and row=10 ) then pix := 60;
		elsif (col=9   and row=10 ) then pix := 52;
		elsif (col=10  and row=10 ) then pix := 53;
		elsif (col=11  and row=10 ) then pix := 32;
		elsif (col=12  and row=10 ) then pix := 44;
		elsif (col=13  and row=10 ) then pix := 38;
		elsif (col=14  and row=10 ) then pix := 0;
		elsif (col=0   and row=11 ) then pix := 0;
		elsif (col=1   and row=11 ) then pix := 37;
		elsif (col=2   and row=11 ) then pix := 41;
		elsif (col=3   and row=11 ) then pix := 42;
		elsif (col=4   and row=11 ) then pix := 34;
		elsif (col=5   and row=11 ) then pix := 41;
		elsif (col=6   and row=11 ) then pix := 53;
		elsif (col=7   and row=11 ) then pix := 48;
		elsif (col=8   and row=11 ) then pix := 53;
		elsif (col=9   and row=11 ) then pix := 41;
		elsif (col=10  and row=11 ) then pix := 34;
		elsif (col=11  and row=11 ) then pix := 42;
		elsif (col=12  and row=11 ) then pix := 41;
		elsif (col=13  and row=11 ) then pix := 37;
		elsif (col=14  and row=11 ) then pix := 0;
		elsif (col=0   and row=12 ) then pix := 0;
		elsif (col=1   and row=12 ) then pix := 0;
		elsif (col=2   and row=12 ) then pix := 34;
		elsif (col=3   and row=12 ) then pix := 40;
		elsif (col=4   and row=12 ) then pix := 46;
		elsif (col=5   and row=12 ) then pix := 40;
		elsif (col=6   and row=12 ) then pix := 36;
		elsif (col=7   and row=12 ) then pix := 34;
		elsif (col=8   and row=12 ) then pix := 36;
		elsif (col=9   and row=12 ) then pix := 40;
		elsif (col=10  and row=12 ) then pix := 46;
		elsif (col=11  and row=12 ) then pix := 40;
		elsif (col=12  and row=12 ) then pix := 34;
		elsif (col=13  and row=12 ) then pix := 0;
		elsif (col=14  and row=12 ) then pix := 0;
		elsif (col=0   and row=13 ) then pix := 0;
		elsif (col=1   and row=13 ) then pix := 0;
		elsif (col=2   and row=13 ) then pix := 0;
		elsif (col=3   and row=13 ) then pix := 35;
		elsif (col=4   and row=13 ) then pix := 34;
		elsif (col=5   and row=13 ) then pix := 43;
		elsif (col=6   and row=13 ) then pix := 47;
		elsif (col=7   and row=13 ) then pix := 49;
		elsif (col=8   and row=13 ) then pix := 47;
		elsif (col=9   and row=13 ) then pix := 43;
		elsif (col=10  and row=13 ) then pix := 34;
		elsif (col=11  and row=13 ) then pix := 35;
		elsif (col=12  and row=13 ) then pix := 0;
		elsif (col=13  and row=13 ) then pix := 0;
		elsif (col=14  and row=13 ) then pix := 0;
		elsif (col=0   and row=14 ) then pix := 0;
		elsif (col=1   and row=14 ) then pix := 0;
		elsif (col=2   and row=14 ) then pix := 0;
		elsif (col=3   and row=14 ) then pix := 0;
		elsif (col=4   and row=14 ) then pix := 0;
		elsif (col=5   and row=14 ) then pix := 35;
		elsif (col=6   and row=14 ) then pix := 32;
		elsif (col=7   and row=14 ) then pix := 30;
		elsif (col=8   and row=14 ) then pix := 32;
		elsif (col=9   and row=14 ) then pix := 35;
		elsif (col=10  and row=14 ) then pix := 0;
		elsif (col=11  and row=14 ) then pix := 0;
		elsif (col=12  and row=14 ) then pix := 0;
		elsif (col=13  and row=14 ) then pix := 0;
		elsif (col=14  and row=14 ) then pix := 0;
		else pix := 0; end if;

		return conv_std_logic_vector(pix,6);
	end pix_g;

	--- bitmap blue pixels ---
	function pix_b(col: std_logic_vector; row: std_logic_vector) return std_logic_vector is
		variable pix: integer range 0 to 2**5-1;
	begin
		   if (col=0   and row=0  ) then pix := 0;
		elsif (col=1   and row=0  ) then pix := 0;
		elsif (col=2   and row=0  ) then pix := 0;
		elsif (col=3   and row=0  ) then pix := 0;
		elsif (col=4   and row=0  ) then pix := 0;
		elsif (col=5   and row=0  ) then pix := 30;
		elsif (col=6   and row=0  ) then pix := 29;
		elsif (col=7   and row=0  ) then pix := 29;
		elsif (col=8   and row=0  ) then pix := 29;
		elsif (col=9   and row=0  ) then pix := 30;
		elsif (col=10  and row=0  ) then pix := 0;
		elsif (col=11  and row=0  ) then pix := 0;
		elsif (col=12  and row=0  ) then pix := 0;
		elsif (col=13  and row=0  ) then pix := 0;
		elsif (col=14  and row=0  ) then pix := 0;
		elsif (col=0   and row=1  ) then pix := 0;
		elsif (col=1   and row=1  ) then pix := 0;
		elsif (col=2   and row=1  ) then pix := 0;
		elsif (col=3   and row=1  ) then pix := 29;
		elsif (col=4   and row=1  ) then pix := 30;
		elsif (col=5   and row=1  ) then pix := 31;
		elsif (col=6   and row=1  ) then pix := 31;
		elsif (col=7   and row=1  ) then pix := 31;
		elsif (col=8   and row=1  ) then pix := 31;
		elsif (col=9   and row=1  ) then pix := 31;
		elsif (col=10  and row=1  ) then pix := 30;
		elsif (col=11  and row=1  ) then pix := 29;
		elsif (col=12  and row=1  ) then pix := 0;
		elsif (col=13  and row=1  ) then pix := 0;
		elsif (col=14  and row=1  ) then pix := 0;
		elsif (col=0   and row=2  ) then pix := 0;
		elsif (col=1   and row=2  ) then pix := 0;
		elsif (col=2   and row=2  ) then pix := 29;
		elsif (col=3   and row=2  ) then pix := 30;
		elsif (col=4   and row=2  ) then pix := 31;
		elsif (col=5   and row=2  ) then pix := 31;
		elsif (col=6   and row=2  ) then pix := 31;
		elsif (col=7   and row=2  ) then pix := 31;
		elsif (col=8   and row=2  ) then pix := 31;
		elsif (col=9   and row=2  ) then pix := 31;
		elsif (col=10  and row=2  ) then pix := 31;
		elsif (col=11  and row=2  ) then pix := 30;
		elsif (col=12  and row=2  ) then pix := 29;
		elsif (col=13  and row=2  ) then pix := 0;
		elsif (col=14  and row=2  ) then pix := 0;
		elsif (col=0   and row=3  ) then pix := 0;
		elsif (col=1   and row=3  ) then pix := 29;
		elsif (col=2   and row=3  ) then pix := 30;
		elsif (col=3   and row=3  ) then pix := 31;
		elsif (col=4   and row=3  ) then pix := 28;
		elsif (col=5   and row=3  ) then pix := 22;
		elsif (col=6   and row=3  ) then pix := 22;
		elsif (col=7   and row=3  ) then pix := 27;
		elsif (col=8   and row=3  ) then pix := 22;
		elsif (col=9   and row=3  ) then pix := 22;
		elsif (col=10  and row=3  ) then pix := 28;
		elsif (col=11  and row=3  ) then pix := 31;
		elsif (col=12  and row=3  ) then pix := 30;
		elsif (col=13  and row=3  ) then pix := 29;
		elsif (col=14  and row=3  ) then pix := 0;
		elsif (col=0   and row=4  ) then pix := 0;
		elsif (col=1   and row=4  ) then pix := 29;
		elsif (col=2   and row=4  ) then pix := 31;
		elsif (col=3   and row=4  ) then pix := 31;
		elsif (col=4   and row=4  ) then pix := 23;
		elsif (col=5   and row=4  ) then pix := 29;
		elsif (col=6   and row=4  ) then pix := 29;
		elsif (col=7   and row=4  ) then pix := 22;
		elsif (col=8   and row=4  ) then pix := 29;
		elsif (col=9   and row=4  ) then pix := 29;
		elsif (col=10  and row=4  ) then pix := 23;
		elsif (col=11  and row=4  ) then pix := 31;
		elsif (col=12  and row=4  ) then pix := 31;
		elsif (col=13  and row=4  ) then pix := 29;
		elsif (col=14  and row=4  ) then pix := 0;
		elsif (col=0   and row=5  ) then pix := 28;
		elsif (col=1   and row=5  ) then pix := 30;
		elsif (col=2   and row=5  ) then pix := 31;
		elsif (col=3   and row=5  ) then pix := 31;
		elsif (col=4   and row=5  ) then pix := 27;
		elsif (col=5   and row=5  ) then pix := 31;
		elsif (col=6   and row=5  ) then pix := 31;
		elsif (col=7   and row=5  ) then pix := 27;
		elsif (col=8   and row=5  ) then pix := 31;
		elsif (col=9   and row=5  ) then pix := 31;
		elsif (col=10  and row=5  ) then pix := 27;
		elsif (col=11  and row=5  ) then pix := 31;
		elsif (col=12  and row=5  ) then pix := 31;
		elsif (col=13  and row=5  ) then pix := 30;
		elsif (col=14  and row=5  ) then pix := 28;
		elsif (col=0   and row=6  ) then pix := 27;
		elsif (col=1   and row=6  ) then pix := 31;
		elsif (col=2   and row=6  ) then pix := 27;
		elsif (col=3   and row=6  ) then pix := 31;
		elsif (col=4   and row=6  ) then pix := 31;
		elsif (col=5   and row=6  ) then pix := 31;
		elsif (col=6   and row=6  ) then pix := 31;
		elsif (col=7   and row=6  ) then pix := 31;
		elsif (col=8   and row=6  ) then pix := 31;
		elsif (col=9   and row=6  ) then pix := 31;
		elsif (col=10  and row=6  ) then pix := 31;
		elsif (col=11  and row=6  ) then pix := 31;
		elsif (col=12  and row=6  ) then pix := 27;
		elsif (col=13  and row=6  ) then pix := 31;
		elsif (col=14  and row=6  ) then pix := 27;
		elsif (col=0   and row=7  ) then pix := 26;
		elsif (col=1   and row=7  ) then pix := 31;
		elsif (col=2   and row=7  ) then pix := 19;
		elsif (col=3   and row=7  ) then pix := 20;
		elsif (col=4   and row=7  ) then pix := 22;
		elsif (col=5   and row=7  ) then pix := 23;
		elsif (col=6   and row=7  ) then pix := 23;
		elsif (col=7   and row=7  ) then pix := 23;
		elsif (col=8   and row=7  ) then pix := 23;
		elsif (col=9   and row=7  ) then pix := 23;
		elsif (col=10  and row=7  ) then pix := 22;
		elsif (col=11  and row=7  ) then pix := 20;
		elsif (col=12  and row=7  ) then pix := 19;
		elsif (col=13  and row=7  ) then pix := 31;
		elsif (col=14  and row=7  ) then pix := 26;
		elsif (col=0   and row=8  ) then pix := 26;
		elsif (col=1   and row=8  ) then pix := 30;
		elsif (col=2   and row=8  ) then pix := 21;
		elsif (col=3   and row=8  ) then pix := 26;
		elsif (col=4   and row=8  ) then pix := 27;
		elsif (col=5   and row=8  ) then pix := 23;
		elsif (col=6   and row=8  ) then pix := 27;
		elsif (col=7   and row=8  ) then pix := 23;
		elsif (col=8   and row=8  ) then pix := 27;
		elsif (col=9   and row=8  ) then pix := 23;
		elsif (col=10  and row=8  ) then pix := 27;
		elsif (col=11  and row=8  ) then pix := 26;
		elsif (col=12  and row=8  ) then pix := 21;
		elsif (col=13  and row=8  ) then pix := 30;
		elsif (col=14  and row=8  ) then pix := 26;
		elsif (col=0   and row=9  ) then pix := 26;
		elsif (col=1   and row=9  ) then pix := 29;
		elsif (col=2   and row=9  ) then pix := 24;
		elsif (col=3   and row=9  ) then pix := 26;
		elsif (col=4   and row=9  ) then pix := 31;
		elsif (col=5   and row=9  ) then pix := 27;
		elsif (col=6   and row=9  ) then pix := 31;
		elsif (col=7   and row=9  ) then pix := 27;
		elsif (col=8   and row=9  ) then pix := 31;
		elsif (col=9   and row=9  ) then pix := 27;
		elsif (col=10  and row=9  ) then pix := 31;
		elsif (col=11  and row=9  ) then pix := 26;
		elsif (col=12  and row=9  ) then pix := 24;
		elsif (col=13  and row=9  ) then pix := 29;
		elsif (col=14  and row=9  ) then pix := 26;
		elsif (col=0   and row=10 ) then pix := 0;
		elsif (col=1   and row=10 ) then pix := 25;
		elsif (col=2   and row=10 ) then pix := 29;
		elsif (col=3   and row=10 ) then pix := 22;
		elsif (col=4   and row=10 ) then pix := 28;
		elsif (col=5   and row=10 ) then pix := 26;
		elsif (col=6   and row=10 ) then pix := 30;
		elsif (col=7   and row=10 ) then pix := 26;
		elsif (col=8   and row=10 ) then pix := 30;
		elsif (col=9   and row=10 ) then pix := 26;
		elsif (col=10  and row=10 ) then pix := 28;
		elsif (col=11  and row=10 ) then pix := 22;
		elsif (col=12  and row=10 ) then pix := 29;
		elsif (col=13  and row=10 ) then pix := 25;
		elsif (col=14  and row=10 ) then pix := 0;
		elsif (col=0   and row=11 ) then pix := 0;
		elsif (col=1   and row=11 ) then pix := 24;
		elsif (col=2   and row=11 ) then pix := 27;
		elsif (col=3   and row=11 ) then pix := 27;
		elsif (col=4   and row=11 ) then pix := 23;
		elsif (col=5   and row=11 ) then pix := 23;
		elsif (col=6   and row=11 ) then pix := 27;
		elsif (col=7   and row=11 ) then pix := 24;
		elsif (col=8   and row=11 ) then pix := 27;
		elsif (col=9   and row=11 ) then pix := 23;
		elsif (col=10  and row=11 ) then pix := 23;
		elsif (col=11  and row=11 ) then pix := 27;
		elsif (col=12  and row=11 ) then pix := 27;
		elsif (col=13  and row=11 ) then pix := 24;
		elsif (col=14  and row=11 ) then pix := 0;
		elsif (col=0   and row=12 ) then pix := 0;
		elsif (col=1   and row=12 ) then pix := 0;
		elsif (col=2   and row=12 ) then pix := 23;
		elsif (col=3   and row=12 ) then pix := 27;
		elsif (col=4   and row=12 ) then pix := 29;
		elsif (col=5   and row=12 ) then pix := 26;
		elsif (col=6   and row=12 ) then pix := 24;
		elsif (col=7   and row=12 ) then pix := 23;
		elsif (col=8   and row=12 ) then pix := 24;
		elsif (col=9   and row=12 ) then pix := 26;
		elsif (col=10  and row=12 ) then pix := 29;
		elsif (col=11  and row=12 ) then pix := 27;
		elsif (col=12  and row=12 ) then pix := 23;
		elsif (col=13  and row=12 ) then pix := 0;
		elsif (col=14  and row=12 ) then pix := 0;
		elsif (col=0   and row=13 ) then pix := 0;
		elsif (col=1   and row=13 ) then pix := 0;
		elsif (col=2   and row=13 ) then pix := 0;
		elsif (col=3   and row=13 ) then pix := 23;
		elsif (col=4   and row=13 ) then pix := 23;
		elsif (col=5   and row=13 ) then pix := 27;
		elsif (col=6   and row=13 ) then pix := 30;
		elsif (col=7   and row=13 ) then pix := 31;
		elsif (col=8   and row=13 ) then pix := 30;
		elsif (col=9   and row=13 ) then pix := 27;
		elsif (col=10  and row=13 ) then pix := 23;
		elsif (col=11  and row=13 ) then pix := 23;
		elsif (col=12  and row=13 ) then pix := 0;
		elsif (col=13  and row=13 ) then pix := 0;
		elsif (col=14  and row=13 ) then pix := 0;
		elsif (col=0   and row=14 ) then pix := 0;
		elsif (col=1   and row=14 ) then pix := 0;
		elsif (col=2   and row=14 ) then pix := 0;
		elsif (col=3   and row=14 ) then pix := 0;
		elsif (col=4   and row=14 ) then pix := 0;
		elsif (col=5   and row=14 ) then pix := 22;
		elsif (col=6   and row=14 ) then pix := 21;
		elsif (col=7   and row=14 ) then pix := 21;
		elsif (col=8   and row=14 ) then pix := 21;
		elsif (col=9   and row=14 ) then pix := 22;
		elsif (col=10  and row=14 ) then pix := 0;
		elsif (col=11  and row=14 ) then pix := 0;
		elsif (col=12  and row=14 ) then pix := 0;
		elsif (col=13  and row=14 ) then pix := 0;
		elsif (col=14  and row=14 ) then pix := 0;
		else pix := 0; end if;

		return conv_std_logic_vector(pix,5);
	end pix_b;

end smile_lol_2;
